# JSONDiff

`JSONDiff` tests compare `JSON` output(s) for the test to a reference in the specified
`gold_dir` folder. `JSON` output is generated by certain user objects, by the mesh, and by reporters (for example,
the `PerfGraphReporter` or the `MeshInfo` reporter).

## Options

Test configuration options are added to the `tests` file.

- `jsondiff`: A list of `JSON` files to compare

- `skip_keys`: A list of keys to skip in the `JSON` comparison

- `abs_zero`: Sets an absolute zero cutoff used in comparisons, defaults to 1e-10.

- `rel_err`: Sets a relative error comparison tolerance, defaults to 5.5e-6.

Other test commands & restrictions may be found in the [TestHarness documentation](TestHarness.md).

### MOOSE-Specific

The following options are specific to MOOSE JSON output:

- `keep_system_information`: Whether or not to diff the system information reported by MOOSE; this defaults to false because typically diffing on executable name, run time, etc, is not useful for testing
- `keep_reporter_types` Whether or not to diff the reporter types output by the MOOSE reporter system

## Example test configuration in the MOOSE test suite

In this example, the mesh output by a [RenameBlockGenerator.md] is being checked using a
`MeshInfo` reporter, which outputs a `JSON` file. This `JSON` file is compared to a reference to
make sure the mesh block names are properly changed.

!listing test/tests/meshgenerators/rename_block_generator/tests
